#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdlib.h>
#include <time.h>

#include "../include/funcvar.h"
#include "../include/widget.h"
#include "../include/support.h"

void nettoyage_table()
{
 int i;
 for(i=0;i<40;i++)
 {
     gtk_image_set_from_file         ((gpointer)prop[i], NULL);
 }
 
 for(i=0;i<10;i++)
 {
     gtk_image_set_from_file         ((gpointer)m[i], NULL);
     gtk_image_set_from_file         ((gpointer)g[i], NULL);
 }
 
  for(i=0;i<4;i++)
 {
     gtk_image_set_from_file         ((gpointer)sol[i], NULL);
 }

//planquer la solution
gtk_widget_hide (solbox);    
}

void nouvelle_combinaison()
{
	int buff;
	int flag;
	unsigned int seed;	// initialisation  //
	seed=time(NULL);    // du generateur   //
	srand(seed);		// pseudo-aleatoire//
	int i; 				// boucle for
	int j;
	
	for(i=0;i<4;i++)
	{
       flag = 0;
       buff=rand()%7;

 	   for (j=0;j<i;j++)
       {
			if (buff == comb[j])
				flag = 1;
       }

        if (flag == 1)
		    i--;
		else
			comb[i]=buff;
    }
   
//remplir la fenetre de solution
   
   	for(i=0;i<4;i++)
	{
       lastprop[i]=9;	 //purge		
	   switch(comb[i])
       {
        case 0: gtk_image_set_from_file         ((gpointer)sol[i], "images/bbleue.gif");break;
        case 1: gtk_image_set_from_file         ((gpointer)sol[i], "images/bverte.gif");break;
        case 2: gtk_image_set_from_file         ((gpointer)sol[i], "images/bjaune.gif");break;
        case 3: gtk_image_set_from_file         ((gpointer)sol[i], "images/brouge.gif");break;
        case 4: gtk_image_set_from_file         ((gpointer)sol[i], "images/bgris.gif");break;
        case 5: gtk_image_set_from_file         ((gpointer)sol[i], "images/bmarron.gif");break;
        case 6: gtk_image_set_from_file         ((gpointer)sol[i], "images/bviolet.gif");break;
       }
    }
//purge     
    proposition=0;	
}

void verifier_combinaison()
{
    int j;			// boucle for calcul des bads
	int i;			// boucles for calculs des oks
	int ok;		// couleurs bien places
	int bad;	// mal places
	
//verifier qu'il y ait bien 4 reponses:
   for (i=0; i<4; i++)
   {
       if(lastprop[i] == 9) //t'as pas 4 reponses: va tupperware
            return;
   }
   ok = 0;		
   bad = 0;	//comb[4] lastprop[4]
   for (i=0; i<4; i++)
   {
			
      if (comb[i] == lastprop[i]) 
         ok++;				
      else 
      {
		 for (j=0; j<4; j++)
         {
				if (lastprop[i] == comb[j])
					bad++;
		 }
      }

	}
//donner le resultat des bons/mauvais:
    switch(ok) //bons
    {
        case 0:gtk_image_set_from_file         ((gpointer)g[proposition], "images/ok0.gif");break;
        case 1:gtk_image_set_from_file         ((gpointer)g[proposition], "images/ok1.gif");break;
        case 2:gtk_image_set_from_file         ((gpointer)g[proposition], "images/ok2.gif");break;
        case 3:gtk_image_set_from_file         ((gpointer)g[proposition], "images/ok3.gif");break;
        case 4:gtk_image_set_from_file         ((gpointer)g[proposition], "images/ok4.gif");break;
    } 
    switch(bad) //mauvais
    {
        case 0:gtk_image_set_from_file         ((gpointer)m[proposition], "images/bad0.gif");break;
        case 1:gtk_image_set_from_file         ((gpointer)m[proposition], "images/bad1.gif");break;
        case 2:gtk_image_set_from_file         ((gpointer)m[proposition], "images/bad2.gif");break;
        case 3:gtk_image_set_from_file         ((gpointer)m[proposition], "images/bad3.gif");break;
        case 4:gtk_image_set_from_file         ((gpointer)m[proposition], "images/bad4.gif");break;
    }            	
	
	
	if (ok == 4)
	{
	   joueur_gagne();
	   gtk_widget_show(solbox);
    }   
    else if ( proposition==9)
    {
       joueur_perds();
       gtk_widget_show(solbox);
    }   
    else
        proposition++;
//nettoyage du buffer proposition
        
    for(i=0;i<4;i++)
	{
       lastprop[i]=9; 
    }      
}

void joueur_gagne()
{
     gtk_widget_show(f_gagne);
}

void joueur_perds()
{
     gtk_widget_show(f_perdu);    
}

void tri_n_savescore()
{
	player buff;
	FILE *save;
	save = fopen("mmv2.sav","r+");
	int i,j,k,l,m;	
	cjoueur.score = 10 - proposition;
    i = lecture_classement();
	
	for(j=0;j<i;j++) // ou l'on vas determiner la place du joueur dans le tableau
	{
	  if (cjoueur.score > top_ten[j].score) break;
	}
	
	cjoueur.place=j;
	for(k = i; k>j;k--) // ou l'on place le joueur a sa place, et decale chaque joueur suivant
	{
		buff = top_ten[k];
		top_ten[k+1] = buff;
		top_ten[k+1].place = buff.place + 1;
	}
	top_ten[j]=cjoueur;
	
    if (cjoueur.place == i - 1) 
       m = i; // on s'assure que le joueur n'est pas dernier, sinon il n'y as personne derriere
	
    else m = i+1; //sinon on as rajouté un joueur dans la liste
	
	fseek( save, 0L, SEEK_SET );
	for(l = 0;(l<m && l < 10); l++) // ou l'on re-ecris le tableau de player dans le file
	{
	fprintf(save,"\t%d\t%d\t%s\n",top_ten[l].place, top_ten[l].score, top_ten[l].nick);
	}	
fclose(save);
}

void show_top10()
{
    player pnull;    
	char buffer[5];
	
	pnull.score=0;
    strcpy(pnull.nick,"Gus");
	
	int i;
	for(i = 0; i<11; i++)
	{
       top_ten[i]=pnull;   
    }

    lecture_classement();
	
	for(i = 0; i<10; i++)
	{
	      snprintf(buffer,sizeof(buffer),"%d",top_ten[i].score);
          gtk_label_set_text   (GTK_LABEL(joueur[i]),top_ten[i].nick);
          gtk_label_set_text   (GTK_LABEL(score[i]),buffer);		
     }	
}

int lecture_classement()
{
    FILE *save;
    int i;
	save = fopen("mmv2.sav","r+");
	
    if (save == NULL) 
    {
       save = fopen("mmv2.sav","w");
		return 0;
    }  
	fseek( save, 0L, SEEK_SET );
	
	for(i = 0; i<10; i++) // on remplit notre tableau de player avec le contenu du file
	{
		if(!feof(save))
			fscanf(save,"\t%d\t%d\t%s\n",&top_ten[i].place, &top_ten[i].score, &top_ten[i].nick);
		else
			break;
     }
     return i;
}

int isclassable()
{
     if(top_ten[9].score < 10 - proposition)
          return 1;
     
     return 0;     
}

void get_player_name()
{
     strcpy(cjoueur.nick, gtk_editable_get_chars (GTK_EDITABLE(nhs_nameentry) ,0,19));
}
